/*
* This file is the main code of Texdi
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
*
* Texdi is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Texdi is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Texdi.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include "tedi2html.h"
using namespace std;
/*
 * This function converts a string with Tedi format and return 
 * a string with HTML format.
 * Header and footer are by default void.
 * TODO: Cleanup, table function
 */
string tedi2html(string text, string header="", string footer=""){
	stringstream index(text);
	string line;
	string return_text;
	int control=0;
	int open_brackets=0;
	while(getline(index,line)){
		size_t np=line.find("<");

		size_t np2=line.find(">");
		if(line[0]!='<'){
			size_t inicio=line.find("!head");
			size_t fin=line.find("!end");
			if(inicio!=std::string::npos or fin!=std::string::npos){
				if(inicio!=std::string::npos){
					return_text+=header + "\n";
				}
				if(fin!=std::string::npos){
					return_text+=footer + "\n";
				}
			}else{
				size_t almo=line.find('#');
				if(almo!=std::string::npos){
					line=titles_ht(line);
					return_text+=line+"\n";
				}
				size_t ul=line.find("__");
				if(ul!=std::string::npos){
					return_text+="<ul>\n";
				}
				size_t li=line.find("--");
				if(li!=std::string::npos){
					std::string parte1;
					li+=2;
					parte1=line.substr(li,line.length()-1);
					if(li==2){
						line="<li>"+parte1;
					}else{
						std::string aux;
						aux=line.substr(0,li-2);
						line=aux+"<li>"+parte1;
					}
				}
				size_t ulf=line.find(",,");
				if(ulf!=std::string::npos){
					return_text+="</ul>\n";
				}
				size_t comi=line.find("\"");
				if(comi!=std::string::npos){
					line=line.substr(1,line.size()-2);
				}else{
					int etiq=main_tag(line);
					while(etiq!=-1){
						//cout << line << etiq << endl;
						if(etiq==2){
							size_t lla2=line.find("}");
							if(lla2==std::string::npos){
								++open_brackets;
								line=incomplete_blocks_ht(line);
							}else{
								line=blocks_ht(line);
							}
						}else{
							if(etiq==0){
								size_t par1=line.find("(");
								if(par1!=std::string::npos ){
									line=images_ht(line);
								}
							}else{
								line=links_ht(line);
							}
						}
						etiq=main_tag(line);
					}
				}
				size_t lla2=line.find("}");
				if(lla2!=std::string::npos){
					--open_brackets;
					line=line.erase(lla2,1);
					line=line.insert(lla2,"</div>");
				}
				size_t hor=line.find("|");
				size_t hor1=line.rfind("|");
				if(hor!=std::string::npos && hor!=hor1 && control==0){
					return_text+="<table>\n<tr>\n";
					++hor;
					line=line.substr(hor,line.size()-1);
					hor=line.find("|");
					int tam=line.size()-1;
					while(hor!=std::string::npos && line[tam]=='|'){
						std::string elemento;
						elemento=line.substr(0,hor);
						return_text+="<td>"+elemento+"</td>\n";
						++hor;
						line=line.substr(hor,line.size()-1);
						hor=line.find("|");
						tam=line.size()-1;
					}
					return_text+="</tr>\n";
					control=1;
				}else{
					if(control==1 && hor==std::string::npos){
						return_text+="</table>\n";
						control=0;
					}else if(control==1 && hor!=std::string::npos){
						return_text+="<tr>\n";
						++hor;
						line=line.substr(hor,line.size()-1);
						hor=line.find("|");
						int tam=line.size()-1;
						while(hor!=std::string::npos && line[tam]=='|'){
							std::string elemento;
							elemento=line.substr(0,hor);
							return_text+="<td>"+elemento+"</td>\n";
							++hor;
							line=line.substr(hor,line.size()-1);
							hor=line.find("|");
							tam=line.size()-1;
						}
						return_text+="</tr>\n";
					}
				}
				size_t menor=line.rfind(" ");
				if(menor==line.size()-1 && line.size()>1){
					return_text+=line+ "<p>\n";
				}else{
					if(ulf==std::string::npos && ul==std::string::npos && almo==std::string::npos && hor==std::string::npos){
						size_t control6=line.find(">");
						if(comi==std::string::npos){
							return_text+=line+ "\n";
						}else{
							return_text+=line+ "\n";
						}
					}
				}
			}
		}else{
			if(line[1]!='!'){
				if(line[1]=='>'){
					line=line.erase(0,2);
					return_text+=line+ "\n";
				}else{
					line=line.erase(0,1);
					return_text+=line+ "<p>\n";
				}
			}
		}
	}
	return return_text;
}
/*
 * Detects next tag
 * Returns 
 * 0: images
 * 1: links
 * 2: blocks
 * -1: No tag
 */
int main_tag(string line){
	int etiq=-1;
	int cont=line.size();
	size_t lla=line.find("{");
	size_t paren=line.find("(");
	size_t corch=line.find("[");
	if(lla!= string::npos && lla<cont){
		etiq=2;
		cont=lla;
	}
	if(corch != string::npos && corch<cont){
		cont=corch;
		etiq=1;
	}
	if(paren != string::npos && paren<cont){
		etiq=0;
	}
	return etiq;
}
string links_ht(string line){
	size_t corchete=line.find("[(");
	string aux="<a href=\"";
	if(corchete!= std::string::npos){
		line=line.erase(corchete,2);
		line=line.insert(corchete,aux);

		corchete=line.find(")");
		line=line.erase(corchete,1);
		aux="\">";
		line=line.insert(corchete,aux);

		corchete=line.rfind("]");
		line=line.erase(corchete,1);
		aux="</a>";
		line=line.insert(corchete,aux);

	}
	return line;
}
/*
 * Deletes parentheses and adds HTML text of a image.
 *
 */
string images_ht(string line){
	size_t par1=line.find("(");
	size_t par2=line.find(")");
	string aux="<img src=\"";
	if(par2!= std::string::npos){
		size_t pos=par2-par1;
		cout << line << endl;
		string alt=line.substr(par1+1,pos-1);
		line=line.erase(par1,1);
		line=line.insert(par1,aux);

		par2=line.find(")");
		aux="\" alt=\""+alt+"\">";
		line=line.erase(par2,1);
		line=line.insert(par2,aux);
		return line;
	}
}
/*
 * Deletes hashes and adds HTML text of a title.
 *
 */
string titles_ht(string line){
	size_t exa1=line.find("#");
	size_t aux=exa1;
	int ti=0;
	while(exa1!=std::string::npos && line[exa1]=='#'){
		++exa1;
		line=line.substr(exa1,line.size()-1);
		exa1=line.find("#");
		++ti;
	}
	std::string ti2=std::to_string(ti);
	line="<h"+ti2+">"+line+"</h"+ti2+">";
	return line;
}
/*
 * Deletes brackes and parentheses. Adds HTML text 
 * of a <div> container.
 *
 */
string blocks_ht(string line){
	size_t lla1=line.find("{(");
	if(lla1!=std::string::npos){
		cout << line << endl;
		line=line.erase(lla1,2);
		cout << line << endl;
		std::string nop="<div class=\"";
		line=line.insert(lla1,nop);
		cout << line << endl;

		lla1=line.find(")");
		nop="\">";
		line=line.erase(lla1,1);
		line=line.insert(lla1,nop);
		cout << line << endl;

		lla1=line.rfind("}");
		nop="</div>";
		line=line.erase(lla1,1);
		line=line.insert(lla1,nop);
		cout << line << endl;
	}
	return line;
}
/*
 * Deletes brackes and parentheses. Adds HTML text 
 * of a <div> container.
 *
 */
string incomplete_blocks_ht(std::string line){
	size_t par_nuevo=line.find("(");
	size_t par2=line.find(")");
	size_t lla1=line.find("{");
	if(par2!= std::string::npos){
		par_nuevo+=1;
		par2=par2-par_nuevo;
		std::string enlace;
		enlace=line.substr(par_nuevo,par2);
		par_nuevo=line.find("(");
		par2=line.find(")");
		lla1=line.find("{");
		size_t lla2=line.rfind("}");
		std::string parte1;
		if(lla1!=0)
			parte1=line.substr(0,lla1);
		std::string parte2;
		par2+=1;
		lla2=lla2-par2;
		parte2=line.substr(par2);
		if(lla1!=0){
			line=parte1+"<div class=\""+enlace+"\">"+parte2;
		}else {
			line="<div class=\""+enlace+"\">"+parte2;
		}
		return line;
	}
}
