/*
* This file is the main code of Texdi
* Copyright (C) <2016>  <alkeon> [alkeon@autistici.org]
   
* Texdi is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Texdi is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Texdi.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <string>
#include <iostream>
#include <fstream>
#include "tedi2html.h"
#include "tedi2tex.h"
#include "tedi2md.h"
using namespace std;
void clean_stdin(){
    int c;
    do{
        c = getchar();
    } while (c != '\n' && c != EOF);
}

int main(int argc, char* argv[]){
	cout <<"Texdi"<<endl;

	int num;
	string input;
	string output;
	
	if(argc==2){
		input=string(argv[1]);
		output=input.substr(0,input.length()-3);
	}else{
		cout <<"Escriba el nombre y extensión del archivo"<<endl;
		char char_input[100];
		cin.getline(char_input,100);
		input=string(char_input);
		output=input.substr(0,input.length()-3);
		clean_stdin();
	}
	do{
		cout <<"1.- HTML"<<endl;
		cout <<"2.- TEX"<<endl;
		cout <<"3.- MD"<<endl;
		cin >> num;
	}while(num<1 && num>3);
	if(test_file(input)){

		switch(num){
			case 1:{
				output+=".html";
				string header="<!DOCTYPE html>\n\n<!-- Hecho con Texdi -->\n\n " //
					"<html lang=\"es\">\n<head>\n\t<link type=\"text/css\"" //
					"rel=\"stylesheet\" href=\"estilos.css\">\n\t<meta charset=\"utf-8\">\n</head>\n<body>";
				string footer="\n</body>\n</html>";
				ifstream reader(input);
				string line;
				string text;
				while(getline(reader,line))
					text+=line+"\n";
				reader.close();
				text=tedi2html(text, header, footer);
				ofstream writer(output);
				writer << text;
			};break;
			case 2:{
				output+=".tex";
				cout << output << endl;
				string author_s;
				char author[100];
				cout << "Añada el autor y si no quiere añadirlo, escriba 0"<<endl;
				clean_stdin();
				cin.getline(author,100);
				string encabezado="\\documentclass[11pt]{article}\n\\usepackage{graphicx}\n\\usepackage[utf8]{inputenc}\n\\usepackage{hyperref}\n\\usepackage{underscore}\n\\hypersetup{pageanchor=false}\n\\title{"+input.substr(0,input.length()-3)+"}\n\\date{}";
				cout << "prueba: "<<author << endl;
				if(author[0]!='0'){
					author_s=string(author);
					encabezado+="\n\\author{"+author_s+"}";
				}
				encabezado+="\n\\setlength\\parindent{0pt}\n\\begin{document}\n\\renewcommand{\\contentsname}{Índice general}\n\\maketitle\n\\newpage\n\\thispagestyle{empty}\n\\tableofcontents\n\\newpage\n\\setcounter{page}{1}\n";
				string pie="\\end{document}";

				info_tex(input,output,encabezado,pie);
				cout << "Conversión terminada"  << endl;
			};break;
			case 3:{
				cout << "Experimental" << endl;
				output+=".md";
				string encabezado="/* Hecho con Texdi */ ";
				string pie=" ";
				traduccion_md(input, output, encabezado, pie);
			};break;
			default: cout << "Opción no permitida" << endl;
		}
	}else{
		cout << "Conversion failed" << endl;
	}
}

