/*
* This file is the main code of Texdi
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Texdi is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Texdi is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Texdi.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include "tedi2html.h"
#include "tedi2tex.h"
#include "tedi2md.h"
using namespace std;

void traduccion_md(std::string archivo,std::string archivo_final,std::string encabezado,std::string pie){
	std::ifstream inicio(archivo.c_str());
	std::string line;
	std::string texto;
	std::ofstream texto2(archivo_final.c_str());
	int control=0;
	int llave_abierta=0;
	while(getline(inicio,line)){
		size_t np=line.find("<");
		size_t comi=line.find("\"");
		size_t np2=line.find(">");
		if(line[0]!='<'){
			size_t inicio=line.find("!head");
			size_t fin=line.find("!end");
			if(inicio!=std::string::npos or fin!=std::string::npos){
				if(inicio!=std::string::npos){
					texto+=encabezado + "\n";
				}
				if(fin!=std::string::npos){
					texto+=pie + "\n";
				}
			}else{
				size_t almo=line.find('#');
				if(almo!=std::string::npos){
					line=titulo_md(line);
					texto+=line+"\n";
				}
				size_t ul=line.find("__");
				if(ul!=std::string::npos){
					texto+="\n";
				}
				size_t li=line.find("--");
				if(li!=std::string::npos){
					std::string parte1;
					li+=2;
					parte1=line.substr(li,line.length()-1);
					if(li==2){
						line="*    "+parte1;
					}else{
						std::string aux;
						aux=line.substr(0,li-2);
						line=aux+"*    "+parte1;
					}
				}
				size_t ulf=line.find(",,");
				if(ulf!=std::string::npos){
					texto+="\n";
				}
				size_t comi=line.find("\"");
				if(comi!=std::string::npos){
					line=line.substr(1,line.size()-2);
				}else{
					int etiq=etiqueta_principal_md(line);
					while(etiq!=-1){
						//cout << line << etiq << endl;
						if(etiq==2){
							size_t lla2=line.find("}");
							if(lla2==std::string::npos){
								++llave_abierta;
								line=contenedores_incompletos_md(line);
							}else{
								line=contenedores_md(line);
							}
						}else{
							if(etiq==0){
								size_t par1=line.find("(");
								if(par1!=std::string::npos ){
									line=imagenes_md(line);
								}
							}else{
								line=enlaces_md(line);
							}
						}
						etiq=etiqueta_principal_md(line);
					}
				}
				size_t lla2=line.find("}");
				if(lla2!=std::string::npos){
					--llave_abierta;
					line=line.erase(lla2,1);
				}
				size_t hor=line.find("|");
				size_t hor1=line.rfind("|");
				if(hor!=std::string::npos && hor!=hor1 && control==0){
					texto+="<table>\n<tr>\n";
					++hor;
					line=line.substr(hor,line.size()-1);
					hor=line.find("|");
					int tam=line.size()-1;
					while(hor!=std::string::npos && line[tam]=='|'){
						std::string elemento;
						elemento=line.substr(0,hor);
						texto+="<td>"+elemento+"</td>\n";
						++hor;
						line=line.substr(hor,line.size()-1);
						hor=line.find("|");
						tam=line.size()-1;
					}
					texto+="</tr>\n";
					control=1;
				}else{
					if(control==1 && hor==std::string::npos){
						texto+="</table>\n";
						control=0;
					}else if(control==1 && hor!=std::string::npos){
						texto+="<tr>\n";
						++hor;
						line=line.substr(hor,line.size()-1);
						hor=line.find("|");
						int tam=line.size()-1;
						while(hor!=std::string::npos && line[tam]=='|'){
							std::string elemento;
							elemento=line.substr(0,hor);
							texto+="<td>"+elemento+"</td>\n";
							++hor;
							line=line.substr(hor,line.size()-1);
							hor=line.find("|");
							tam=line.size()-1;
						}
						texto+="</tr>\n";
					}
				}
				size_t menor=line.rfind(" ");
				if(menor==line.size()-1 && line.size()>1){
					texto+=line+ "<p>\n";
				}else{
					if(ulf==std::string::npos && ul==std::string::npos && almo==std::string::npos && hor==std::string::npos){
						size_t control6=line.find(">");
						if(comi==std::string::npos){
							texto+=line+ "\n";
						}else{
							texto+=line+ "\n";
						}
					}
				}
			}
		}else{
			if(line[1]!='!'){
				if(line[1]=='>'){
					line=line.erase(0,2);
					texto+=line+ "\n";
				}else{
					line=line.erase(0,1);
					texto+=line+ "\n";
				}
			}
		}
	}
	texto2 << texto;
	inicio.close();
	
}

int etiqueta_principal_md(string line){
	int etiq=-1;
	int cont=line.size();
	size_t lla=line.find("{");
	size_t paren=line.find("(");
	size_t corch=line.find("[");
	if(lla!= std::string::npos && lla<cont){
		etiq=2;
		cont=lla;
	}
	if(corch != std::string::npos && corch<cont){
		cont=corch;
		etiq=1;
	}
	if(paren != std::string::npos && paren<cont){
		etiq=0;
	}
	return etiq;
}
string enlaces_md(std::string line){
	size_t corchete=line.find("[(");
	string aux="<a href=\"";
	if(corchete!= std::string::npos){
		line=line.erase(corchete,2);
		line=line.insert(corchete,aux);

		corchete=line.find(")");
		line=line.erase(corchete,1);
		aux="\">";
		line=line.insert(corchete,aux);

		corchete=line.rfind("]");
		line=line.erase(corchete,1);
		aux="</a>";
		line=line.insert(corchete,aux);

	}
	return line;
}
string imagenes_md(std::string line){
	size_t par1=line.find("(");
	size_t par2=line.find(")");
	string aux="<img src=\"";
	if(par2!= std::string::npos){
		size_t pos=par2-par1;

		string alt=line.substr(par1+1,pos-1);
		line=line.erase(par1,1);
		line=line.insert(par1,aux);

		par2=line.find(")");
		aux="\" alt=\""+alt+"\">";
		line=line.erase(par2,1);
		line=line.insert(par2,aux);
		return line;
	}
}

string titulo_md(std::string line){
	size_t exa1=line.find("#");
	size_t aux=exa1;
	int ti=0;
	while(exa1!=std::string::npos && line[exa1]=='#'){
		++exa1;
		line=line.substr(exa1,line.size()-1);
		exa1=line.find("#");
		++ti;
	}
	if(ti==0){
		line+="\n===\n";
	}else{
		line+="\n---\n";
	}
	return line;
	
}

string contenedores_md(std::string line){
	size_t par2=line.find(")");
	if(par2!= std::string::npos){
		size_t lla1=line.find("{(");
		line=line.erase(lla1,2);
		size_t lla2=line.rfind("}");
		line=line.erase(lla2,1);
		par2=line.find(")");
		line=line.erase(par2,1);
		return line;
	}

}

string contenedores_incompletos_md(std::string line){
	size_t par2=line.find(")");
	if(par2!= std::string::npos){
		size_t lla1=line.find("{(");
		line=line.erase(lla1,2);
		par2=line.find(")");
		line=line.erase(par2,1);
		return line;
		
	}
}
