/*
* This file is the main code of Texdi
* Copyright (C) <2016>  <alkeon> [alkeon@autistici.org][PGP sign]
   
* Texdi is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Texdi is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
*
*/
#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include "tedi2tex.h"
#include <list>
using namespace std;

void traduccion_tex(std::string archivo,std::string archivo_final,std::string encabezado,std::string pie, std::list<int>& tabla){
	std::ifstream inicio(archivo.c_str());
	std::string line;
	std::string texto;
	std::ofstream texto2(archivo_final.c_str());
	int control=0;
	int llaves_abiertas=0;
	while(getline(inicio,line)){
		size_t np=line.find("<");
		size_t comi=line.find("\"");
		size_t ul=line.find('_');
		if(line[0]!='<'){
			//Change all _ to \_ Latex uses _ as underscore
			while(ul!=std::string::npos){
				size_t ul2=line.find("__");
				if(ul2==std::string::npos){
					line=line.insert(ul,1,'\\');
				}
				ul=line.find('_',ul+2);
			}
			size_t excla1=line.find("!head");
			size_t fin=line.find("!end");
			if(excla1!=std::string::npos or fin!=std::string::npos){
				if(excla1!=std::string::npos){
					line=encabezado;
					texto+=line + "\n";
				}
				if(fin!=std::string::npos){
					line=pie;
					texto+=line + "\n";
				}
			}else{
				size_t almo=line.find('#');
				if(almo!=std::string::npos){
					line=titulo_tex(line);
					texto+=line+"\n";
				}else{
					size_t ul=line.find("__");
					if(ul!=std::string::npos){
						texto+="\\begin{itemize}\n";
					}
					size_t li=line.find("--");
					if(li!=std::string::npos){
						std::string parte1;
						li+=2;
						parte1=line.substr(li,line.length()-1);
						if(li==2){
							line="\\item "+parte1+"\n";
						}else{
							std::string aux;
							aux=line.substr(0,li-2);
							if(comi!=std::string::npos){
								line=aux+"\\item "+parte1;
							}else{
								line=aux+"\\item "+parte1+"\n";
							}
						}
					}
					size_t ulf=line.find(",,");
					if(ulf!=std::string::npos){
						texto+="\\end{itemize}\n";
					}
					comi=line.find("\"");
					if(comi!=std::string::npos){
						line=line.substr(1,line.size()-2);
					}else{
						int etiq=etiqueta_principal_tex(line);
						while(etiq!=-1){
							if(etiq==2){
								size_t lla2=line.find("}");
								if(lla2!=std::string::npos){
									line=contenedores_tex(line);
								}else{
									++llaves_abiertas;
									line=contenedores_incompletos_tex(line);
								}
							}else{
								if(etiq==0){
									size_t par1=line.find("(");
									if(par1!=std::string::npos ){
										cout << line << endl;
										line=imagenes_tex(line);
									}
								}else{
									cout << line << endl;
									line=enlaces_tex(line);
								}
							}
							etiq=etiqueta_principal_tex(line);
						}
					}
					size_t lla2=line.find("}");
					if(lla2!=std::string::npos && llaves_abiertas>0){
						--llaves_abiertas;
						line=line.erase(lla2,1);
					}
					size_t hor=line.find("|");
					size_t hor_c=hor;
					if(hor!=std::string::npos && control==0){
						texto+="\\begin{tabular}{";
						int i=0;
						//std::cout << tabla.front() << std::endl;
						while(i<tabla.front()){
							texto+="|c";
							++i;
						}
						if(i==tabla.front())
							texto+="|}\n";
						tabla.pop_front();
						++hor;
						texto+="\\hline\n";
						line=line.substr(hor,line.size()-1);
						hor=line.find("|");
						int tam=line.size()-1;
						int x=0;
						while(hor!=std::string::npos && line[tam]=='|'){
							std::string elemento;
							elemento=line.substr(0,hor);
							if(x!=0){
								texto+=" &" +elemento;
							}else{
								texto+=elemento;
							}
							++hor;
							line=line.substr(hor,line.size()-1);
							hor=line.find("|");
							tam=line.size()-1;
							++x;
						}
						texto+="\\tabularnewline\n";
						texto+="\\hline\n";
						control=1;
					}else{
						if(control==1 && hor==std::string::npos){
							texto+="\\end{tabular}\n";
							control=0;
						}else if(control==1 && hor!=std::string::npos){
							++hor;
							line=line.substr(hor,line.size()-1);
							hor=line.find("|");
							int tam=line.size()-1;
							int x=0;
							while(hor!=std::string::npos && line[tam]=='|'){
								std::string elemento;
								elemento=line.substr(0,hor);
								if(x!=0){
									texto+=" &" +elemento;
								}else{
									texto+=elemento;
								}
								++hor;
								++x;
								line=line.substr(hor,line.size()-1);
								hor=line.find("|");
								tam=line.size()-1;
							}
							texto+="\\tabularnewline\n";
							texto+="\\hline\n";
						}
					}
					size_t menor=line.rfind(" ");
					size_t control2=line.find('>');
					if(menor==line.size()-1 && control2==std::string::npos && line.size()>1){
						texto+=line+ "\n\n";
					}else{
						if(ulf==std::string::npos && ul==std::string::npos && almo==std::string::npos && hor==std::string::npos){
							if(comi==std::string::npos or hor_c!=std::string::npos or li!=std::string::npos){
								texto+=line+ "\n";
							}else{
								texto+=line+ "\n\n";
							}
						}
					}
				}
			}
		}else{
			if(line[1]!='!'){
				if(line[1]!='>'){
					line=line.erase(0,1);
					texto+= "\\verb!"+line+ "!\n\n";
				}else{
					line=line.erase(0,2);
					texto+=line+ "\n\n";
				}
			}
		}
	}
	texto2 << texto;
	inicio.close();
	texto2.close();
}

int etiqueta_principal_tex(string line){
	int etiq=-1;
	size_t lla=line.find("{(");
	size_t paren=line.find("(");
	size_t corch=line.find("[(");
	if(corch<lla){
		lla=corch;
		etiq=1;
	}
	if(paren<lla){
		etiq=0;
	}
	if(corch>lla && paren>lla && lla!=std::string::npos && etiq==-1){
		etiq=2;
	}
	return etiq;
}

string enlaces_tex(std::string line){
	size_t corchete=line.find("[(");
	string aux="\\href{";
	if(corchete!= std::string::npos){
		line=line.erase(corchete,2);
		line=line.insert(corchete,aux);

		corchete=line.find(")");
		line=line.erase(corchete,1);
		aux="}{";
		line=line.insert(corchete,aux);

		corchete=line.rfind("]");
		line=line.erase(corchete,1);
		aux="}";
		line=line.insert(corchete,aux);

	}
	return line;
}

string imagenes_tex(std::string line){
	size_t par1=line.find("(");
	size_t par2=line.find(")");
	string aux="\\begin{figure}\n\\centering\n\\includegraphics[width=0.5\\textwidth]{";
	if(par2!= std::string::npos){
		size_t pos=par2-par1;

		string alt=line.substr(par1+1,pos-1);
		line=line.erase(par1,1);
		line=line.insert(par1,aux);

		par2=line.find(")");
		size_t point=alt.rfind(".");
		if(point!=std::string::npos){
			string caption=alt.substr(0,point);
			aux="}\n\\caption{"+caption+"}\n\\end{figure}";
		}else{
			aux="}\n\\end{figure}";
		}
		line=line.erase(par2,1);
		line=line.insert(par2,aux);
		return line;
	}
}

string titulo_tex(std::string line){
	//size_t exa2=line.find("##");
	size_t exa1=line.find('#');
	size_t aux=exa1;
	int ti=-1;
	while(exa1!=std::string::npos && line[exa1]=='#'){
		
		++exa1;
		std::cout << line.size()-2 << std::endl;
		
		line=line.substr(exa1,line.size()-1);
		std::cout << line.size() << std::endl;
		std::cout << line << std::endl;
		
		exa1=line.find('#');

		++ti;
	}
	if(ti==0){
		line="\\section{"+line+"}\n";
	}else{
		if(ti==1){
			line="\\subsection{"+line+"}\n";
		}else{
			line="\\subsubsection{"+line+"}\n";
		}
	}
	return line;
	
}

string contenedores_tex(std::string line){
	size_t par2=line.find(")");
	if(par2!= std::string::npos){
		size_t lla1=line.find("{(");
		line=line.erase(lla1,2);
		size_t lla2=line.rfind("}");
		line=line.erase(lla2,1);
		par2=line.find(")");
		line=line.erase(par2,1);
		return line;
	}
}

string contenedores_incompletos_tex(std::string line){
	size_t par2=line.find(")");
	if(par2!= std::string::npos){
		size_t lla1=line.find("{(");
		line=line.erase(lla1,2);
		par2=line.find(")");
		line=line.erase(par2,1);
		return line;
		
	}
}

void info_tex(std::string archivo,std::string archivo_final,std::string encabezado,std::string pie){
	std::list<int> tabla;
	std::ifstream inicio(archivo.c_str());
	std::string line;
	int comprobacion=0;
	while(getline(inicio,line)){
		size_t np=line.find('<');
		if(np==std::string::npos){
			size_t table=line.find('|');
			if(table!=std::string::npos){
				size_t hor=line.find("|");
				size_t hor1=line.rfind("|");
				if(comprobacion==0){
					int datos=0;
					int tam=line.size()-1;
					while(hor!=std::string::npos && (line[tam]=='|' or line[tam-1]=='|')){
					std::string elemento;
					elemento=line.substr(0,hor);
					++hor;
					line=line.substr(hor,line.size()-1);
					std::cout << line << std::endl;
					hor=line.find("|");
					tam=line.size()-1;
					++datos;
					}
					--datos;
					tabla.push_back(datos);
					comprobacion=1;
				}
			}else{
				comprobacion=0;
			}
		}
	}
	traduccion_tex(archivo,archivo_final,encabezado,pie,tabla);
	inicio.close();
	cout << " finaliza funcion info_text"  << endl;
}
